<?php

/**
 * Vvveb
 *
 * Copyright (C) 2022  Ziadin Givan
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

namespace Vvveb\Plugins\Captcha\System;

class Recaptcha {
	public function validate($secret, $response = null) {
		$remote_addr = $_SERVER['REMOTE_ADDR'] ?? '';
		$token       = $response ?? $_POST['g-recaptcha-response'] ?? false;
		$url         = 'https://www.google.com/recaptcha/api/siteverify';

		$data = http_build_query([
			'secret'   => $secret,
			'response' => $token,
			'remoteip' => $remote_addr,
		]);

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

		$response = curl_exec($curl);
		$success  = false;

		if (curl_errno($curl)) {
			$success = curl_error($curl);
		} else {
			$data    = json_decode($response, true);
			$success = $data['success'] ?? false;
		}

		return $success;
	}
}
